# -*- mode: ruby -*-
# vi: set ft=ruby :

$script = <<-SCRIPT
cd /DiscordBot/ollama
tmux new -d "OLLAMA_HOST=0.0.0.0:11435 ./ollama serve"
sleep 20
OLLAMA_HOST=0.0.0.0:11435 ./ollama run llama2:13b
sleep 120
cd /DiscordBot
sudo python3 main.py > /var/log/chatgpt-discord-bot.log 2>&1 &
SCRIPT

Vagrant.configure("2") do |config|
  config.vm.box = "perk/ubuntu-2204-arm64"
  config.ssh.forward_agent = true
  config.vm.synced_folder ".", "/DiscordBot", type: "rsync", rsync__exclude: ".git/"

  config.vm.provider "qemu" do |vb|
  vb.memory = "20480"
  end

  #config.vm.provision :shell, :inline => "ln -s /usr/share/zoneinfo/America/Chicago /etc/localtime", run: "always"

  config.vm.provision "shell", inline: <<-SHELL
    # Install cmake 3.15
    # Remove previous cmake versions
    apt update
    apt-get update
    apt install -y gcc
    apt install -y make
    apt remove -y cmake
    apt purge --auto-remove cmake

    apt-get install -y build-essential
    wget http://www.cmake.org/files/v3.15/cmake-3.15.0.tar.gz
    tar xf cmake-3.15.0.tar.gz

    cd cmake-3.15.0
    ./configure
    make
    # Then to install it to your system finally do 
    sudo make install

    # Do this to refresh your console 
    hash -r

    apt install -y python3.10
    apt install -y whiptail dialog
    apt update
    apt-get install -y gnupg
    apt update
    apt install -y apt-transport-https ca-certificates curl software-properties-common python-software-properties

    apt-get update
    apt install -y wget build-essential libncursesw5-dev libssl-dev libsqlite3-dev tk-dev libgdbm-dev libc6-dev libbz2-dev libffi-dev zlib1g-dev
    
    apt-get install -y libcairo2-dev cargo libfreetype6-dev gcc libgdk-pixbuf2.0-dev gettext libjpeg-dev liblcms2-dev libffi-dev musl-dev libopenjp2-7-dev libssl-dev libpango1.0-dev poppler-utils postgresql-client libpq-dev python3-dev rustc tcl-dev libtiff5-dev tk-dev zlib1g-dev
    apt-get install -y python3-pip
    curl https://sh.rustup.rs -sSf | sh -s -- -y
    export PATH="/root/.cargo/bin:${PATH}"
    rustup update
    pip3 install cryptography

  SHELL

  config.vm.provision "shell", inline: <<-SHELL
    cd /DiscordBot
    pip3 install -r requirements.txt
  SHELL

  config.vm.network "forwarded_port", guest: 11434, host: 11434
  config.vm.network "forwarded_port", guest: 11435, host: 11435

  config.vm.provision "shell", inline: <<-SHELL
    apt-get update

    # Clone the ollama repository
    ssh-keyscan -t rsa github.com >> ~/.ssh/known_hosts
    #git clone git@github.com:jmorganca/ollama.git /ollama

    # clone ollama
    snap install --classic --channel=1.20/stable go
    cd /DiscordBot
    git clone git@github.com:jmorganca/ollama.git

    cd /DiscordBot/ollama
    #go env -w GO111MODULE=off
    go generate ./...
    go build .

    # Start the ollama server
    #OLLAMA_HOST=0.0.0.0:11435 ./ollama serve
    #./ollama serve
    #OLLAMA_HOST=0.0.0.0:11435 ./ollama run llama2

  SHELL
  
  config.vm.provision "shell", run: "always", inline: <<-SHELL
    #sudo apt-key adv --keyserver keyserver.ubuntu.com --recv-keys 7EA0A9C3F273FCD8
    sudo apt-get update
    sudo apt-get install -y ca-certificates curl gnupg
    sudo install -m 0755 -d /etc/apt/keyrings
    curl -fsSL https://download.docker.com/linux/ubuntu/gpg | sudo gpg --dearmor -o /etc/apt/keyrings/docker.gpg
    sudo chmod a+r /etc/apt/keyrings/docker.gpg
    echo \
      "deb [arch="$(dpkg --print-architecture)" signed-by=/etc/apt/keyrings/docker.gpg] https://download.docker.com/linux/ubuntu \
      "$(. /etc/os-release && echo "$VERSION_CODENAME")" stable" | \
      sudo tee /etc/apt/sources.list.d/docker.list > /dev/null
    sudo apt-get update
    sudo apt-get install -y docker-ce docker-ce-cli containerd.io docker-buildx-plugin docker-compose-plugin
    #sudo docker run hello-world
    sudo systemctl start docker
    #systemctl status docker.service
    #systemctl is-enabled docker
    #sudo docker info
    #cd /DiscordBot/ollama
    #tmux new -d "OLLAMA_HOST=0.0.0.0:11435 ./ollama serve"
    #OLLAMA_HOST=0.0.0.0:11435 ./ollama run llama2:13b
    #cd /DiscordBot
    #sudo python3 main.py > /var/log/chatgpt-discord-bot.log 2>&1 &
  SHELL

  config.vm.provision "shell", inline: $script

  #Vagrant.configure("2") do |config|
  #config.vm.provision "shell",
  #  inline: "echo Hello, World"
  #end

end
